"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ComputedTracker = void 0;
class ComputedTracker {
    //=========================================================================================================
    // Track
    //=========================================================================================================
    /**
     * @internal
     * Starts tracking Observers
     */
    static track() {
        this.isTracking = true;
    }
    //=========================================================================================================
    // Tracked
    //=========================================================================================================
    /**
     * @internal
     * Adds passed Observer to tracked Observers, if ComputedTracker is currently tracking
     * @param observer - Observer
     */
    static tracked(observer) {
        if (this.isTracking)
            this.trackedObservers.add(observer);
    }
    //=========================================================================================================
    // Get Tracked Observers
    //=========================================================================================================
    /**
     * @internal
     * Returns tracked Observers and stops tracking anymore Observers
     */
    static getTrackedObservers() {
        const trackedObservers = Array.from(this.trackedObservers);
        // Reset tracking
        this.isTracking = false;
        this.trackedObservers = new Set();
        return trackedObservers;
    }
}
exports.ComputedTracker = ComputedTracker;
ComputedTracker.isTracking = false;
ComputedTracker.trackedObservers = new Set();
