"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.EventObserver = void 0;
const internal_1 = require("../internal");
class EventObserver extends internal_1.Observer {
    /**
     * @internal
     * Event Observer - Handles Event dependencies and ingests Event triggers into the Runtime
     * @param event - Event
     * @param config - Config
     */
    constructor(event, config = {}) {
        super(event.agileInstance(), {
            dependents: config.dependents,
            key: config.key,
            subs: config.subs,
        });
        this.event = () => event;
    }
    //=========================================================================================================
    // Perform
    //=========================================================================================================
    /**
     * @internal
     * Performs Job from Runtime
     * @param job - Job that gets performed
     */
    perform(job) {
        // Noting to perform
    }
}
exports.EventObserver = EventObserver;
