"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RuntimeJob = void 0;
const internal_1 = require("../internal");
class RuntimeJob {
    /**
     * @internal
     * Job - Represents Observer that gets performed by the Runtime
     * @param observer - Observer
     * @param config - Config
     */
    constructor(observer, config = {}) {
        this.performed = false; // If Job has been performed by Runtime
        this.subscriptionContainersToUpdate = new Set(); // SubscriptionContainer that have to be updated/rerendered
        config = internal_1.defineConfig(config, {
            background: false,
            sideEffects: {
                enabled: true,
                exclude: [],
            },
            force: false,
        });
        this.config = {
            background: config.background,
            force: config.force,
            sideEffects: config.sideEffects,
        };
        this.observer = observer;
        this.rerender =
            !config.background &&
                this.observer.agileInstance().integrations.hasIntegration();
        this._key = config.key;
        this.subscriptionContainersToUpdate = new Set(observer.subs);
    }
    get key() {
        return this._key;
    }
    set key(value) {
        this._key = value;
    }
}
exports.RuntimeJob = RuntimeJob;
