"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SubscriptionContainer = void 0;
const internal_1 = require("../../../internal");
class SubscriptionContainer {
    /**
     * @internal
     * SubscriptionContainer - Represents Component/(Way to rerender Component) that is subscribed by Observer/s (Agile)
     * -> Used to cause rerender on Component
     * @param subs - Initial Subscriptions
     * @param key - Key/Name of Subscription Container
     */
    constructor(subs = [], key) {
        this.ready = false;
        // For Object based Subscription
        this.isObjectBased = false;
        this.observerKeysToUpdate = []; // Holds temporary keys of Observers that got updated (Note: keys based on 'subsObject')
        this.subs = new Set(subs);
        this.key = key || internal_1.generateId();
    }
}
exports.SubscriptionContainer = SubscriptionContainer;
